﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace i8026W_Basic_Info_Csharp
{
    public partial class Form1 : Form
    {
        private string[] slotStr = new string[8];
        private int slotIndex;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            slotStr[0] = "Slot 0";
            slotStr[1] = "Slot 1";
            slotStr[2] = "Slot 2";
            slotStr[3] = "Slot 3";
            slotStr[4] = "Slot 4";
            slotStr[5] = "Slot 5";
            slotStr[6] = "Slot 6";
            slotStr[7] = "Slot 7";
            for (i = 0; i < 8; i++)
            {
                cboSlotIndex.Items.Add(slotStr[i]);
            }
        }

        private void cboSlotIndex_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = -1;
            ret = pac8026WNet.pac8026W.Init(cboSlotIndex.SelectedIndex);
            if (ret == 0)
            {
                slotIndex = cboSlotIndex.SelectedIndex;
                txtLibVer.Text = String.Format("{0:X4}", pac8026WNet.pac8026W.LibVersion());

                txtLibDate.Text = pac8026WNet.pac8026W.LibDate();
                txtFirmware.Text = String.Format("{0:X4}", pac8026WNet.pac8026W.FirmwareVersion(slotIndex));
            }
            else
            {
                MessageBox.Show("I-8026W is not at slot " + cboSlotIndex.SelectedIndex.ToString() + ", error code =" + ret.ToString());
                slotIndex = -1;
                txtLibVer.Text = "-1";
                txtLibDate.Text = "none";
                txtFirmware.Text = "-1";
            }
        }

        private void ReadAI_btn_Click(object sender, EventArgs e)
        {
            int ch = 0;
            float aiV = 0;
            TextBox[] aiData = { txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5 };
            Int16 gain = (Int16)cboAIGain.SelectedIndex;
            if (slotIndex != -1)
            {
                for (ch = 0; ch < 6; ch++)
                {
                    try
                    {
                        //Console.WriteLine("rai");
                        pac8026WNet.pac8026W.ReadAI(slotIndex, ch, gain, ref aiV);
                        aiData[ch].Text = String.Format("[{0}]", aiV);
                    }
                    catch (Exception ee)
                    {
                        Console.WriteLine(ee.Message);
                    }
                }

            }
        }

        private void WriteAO0_btn_Click(object sender, EventArgs e)
        {
            Int16 gain = (Int16)cboAOGain.SelectedIndex;
            pac8026WNet.pac8026W.WriteAO(slotIndex, 0, gain, Convert.ToSingle(txtAO0.Text));
        }

        private void WriteAO1_btn_Click(object sender, EventArgs e)
        {
            Int16 gain = (Int16)cboAOGain.SelectedIndex;
            pac8026WNet.pac8026W.WriteAO(slotIndex, 1, gain, Convert.ToSingle(txtAO1.Text));
        }

        private void btnWriteDO_Click(object sender, EventArgs e)
        {
            pac8026WNet.pac8026W.WriteDO(slotIndex, Convert.ToInt16(txtDOOut.Text));
        }

        private void ReadDIO_btn_Click(object sender, EventArgs e)
        {
            Int16 diVal = 0, doVal = 0;
            byte[] diBit = new byte[3];
            byte[] doBit = new byte[3];
            pac8026WNet.pac8026W.ReadDIO(slotIndex, ref diVal, ref doVal, diBit, doBit);
            lbDIVal.Text = diVal.ToString();
            lbDOVal.Text = doVal.ToString();
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}